-------------------------------------------------------------------------------
--
-- Simple VGA raster display
--
-- Stephen A. Edwards
-- sedwards@cs.columbia.edu
--
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity MMC_DATAOUT is
  
  port (
    
    avs_s1_clk        : in  std_logic;
    avs_s1_read      : in  std_logic;
    avs_s1_chipselect : in  std_logic;
    avs_s1_address    : in  std_logic_vector(4 downto 0);
    avs_s1_readdata  : out  std_logic_vector(31 downto 0);

	SD_DAT			 : in std_logic 
  );

end MMC_DATAOUT;

architecture rtl of MMC_DATAOUT is
begin
  process (avs_s1_clk)
  begin
    if avs_s1_clk'event and avs_s1_clk = '1' then
        if avs_s1_chipselect = '1' then
            if avs_s1_read = '1' then
              avs_s1_readdata(0) <= SD_DAT;
            end if;
        end if;
     end if;
  end process;
end architecture rtl;