#include <mmc_header.h>
#include <stdio.h>

unsigned char buffer[] = {
    0x40, 0x00, 0x00, 0x00, 0x00, 0x95
};

unsigned char read_buffer[4096];
int read_buffer_addr = -1;

void delay(int i)
{
    int a;
    for(a=0;a<i;a++)
    {

    }
}

void send_clks(int a,int b)
{
    int i;
    for(i=0;i<a;i++)
    {
        delay(b);
        CLK_HI;
        delay(b);
        CLK_LO;
    }

}

void mmc_init()
{
    CLK_LO;
    DIN_HI;
    NCS_HI;
    send_clks(80,60);
}

void mmc_disable()
{
    CLK_LO;
    DIN_HI;
    NCS_HI;
}

void send_cmd(unsigned  char cmd, unsigned char* arg)
{
   unsigned char *temp;
   unsigned char data;
   int i,j;
   NCS_LO;
   *buffer = 0x40 | cmd;
   for(i=0;i<4;i++)
    *(ARG + i) = *(arg + i);
    temp = CMD;
    for(i=0;i<6;i++)
    {
        for(j=7;j>-1;j--)
        {
            data = *temp;
            data = data >> j;
            data = data & 0x01;
            //printf("-> %x",data);
            data?DIN_HI:DIN_LO;
            send_clks(1,60);
        }
        temp++;
    }
    DIN_HI;
}

unsigned char recv_resp()
{
    unsigned char resp=0x00,temp=0x00;
    int i;
    temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
    while(temp == 1)
    {
        send_clks(1,60);
        temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
    }
    for(i=7;i>-1;i--)
    {
        temp = temp << i;
        resp = resp | temp;
        send_clks(1,60);
        temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
    }
    return resp;
}

unsigned char send_recv_cmd(unsigned char cmd, unsigned char * arg)
{
    send_cmd(cmd, arg);
    return recv_resp();
}

int read_data(unsigned int address, unsigned char * data_buf, int size)
{
    //printf("reading %d bytes at addr=%d\n", size, address);
    address += 57*512;
    unsigned char temp_buf[512];
    int i, bytes;
    if (size == 4096 && read_buffer_addr == address) {
        memcpy((unsigned char *) data_buf, read_buffer, 4096);
        return size;
    }
    else {
        //printf("reading %d bytes at addr=%d\n", size, address - 57*512);
        read_buffer_addr = address;
    }
    
    for (i=0; i<size; i+=512) {
        bytes = (size-i)>512?512:(size-i);
        //printf("copying addr:%d, size=%d\n", i, bytes);
        read_data_block(address + i, temp_buf);
        memcpy((unsigned char *) data_buf + i, temp_buf, bytes);
        memcpy((unsigned char *) read_buffer + i, temp_buf, bytes);
    }
    
    return size;   
}

void read_data_block(unsigned int address, unsigned char * data_buf)
{
  //printf("........reading block %d\n", address);
  unsigned char arg[3];
  unsigned char resp=0x11, temp = 0x00;
  int i,j;
  //printf("\n address in hex %x\n",address);
  for(i=3;i>-1;i--)
  {
    //printf("\n -> %x",address);
    //printf(" -> %x", address & 255);
    arg[i]= (address) & 255;
    address = address >> 8;
  }
      //printf("\n %x %x %x %x \n",arg[0],arg[1],arg[2],arg[3]); 
  resp = send_recv_cmd(resp,arg);
  if(resp != 0x00) {
      //printf("Error sending data Request %x\n",resp);
  }
  temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
  while(temp == 1)
  {
      send_clks(1,60);
      temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
  }
  //printf("Out of while\n");
  for(j=0;j<512;j++)
  {
    resp = 0x00;
    for(i=7;i>-1;i--)
    {
        send_clks(1,0);
        temp=IORD_16DIRECT(MMC_DATAOUT1_BASE,0);
        temp = temp << i;
        resp = resp | temp;
    }
    data_buf[j]=resp;
  }
  send_clks(8,0);
} 
void mmc_super_init(char *arg1)
{
  mmc_init();
  unsigned char resp;
  unsigned char arg[4] = { 0x00, 0x00, 0x00, 0x00 };
  resp = 0x00;
  resp = send_recv_cmd(resp, arg);
  send_clks(8,60);
  //printf("%x This is the response\n",resp);
  resp = 0x01;
  resp = send_recv_cmd(resp, arg);
  send_clks(8,60);
  while(resp == 0x01)
  {
    //printf ("Resp after cmd1 == %x == \n",resp);
    resp = send_recv_cmd(resp,arg);
    send_clks(8,60);
  }
  //printf ("\nLooks like I did it! == %x == \n",resp);
  resp=0x10;
  resp = send_recv_cmd(resp,arg1);
  send_clks(8,60);
  //printf(" Set block length resp == %x == \n",resp);
}

